// #############################################################################
// #
// # Scriptname : HelvePic32.h
// # Author     : Dr. Mathias Wilhelm
// # Contributor: Dominik Wilhelm
// # contact    : 
// # Date       : 2015-03-01
// # Description:
// # Headerfile for the HelvePic32
// # 
// # Version    : 1.0
// #############################################################################

// *********************************************
// DEFINE
// *********************************************
#ifndef HelvePic32_h
#define HelvePic32_h

#if defined(__AVR__)
	#include "Arduino.h"
    uint8_t nP[2][8] = {{ 0, 1, 2, 3, 4, 5, 6, 7},{ 8, 9,10,11,12,13,14,15}}; // dummy pin declaration for transparent compile
#elif defined(__PIC32MX__)
	#include "WProgram.h"
#elif defined(__arm__)
	#include "Arduino.h"
#endif

// *********************************************
// Global Vars
// *********************************************
#define hcbi(reg, bitmask) *reg &= ~bitmask
#define hsbi(reg, bitmask) *reg |= bitmask
const uint8_t LEFT=0;
const uint8_t RIGHT=1;
#if defined(_BOARD_DP32_)
uint8_t nP[2][8] = {{ 0,17, 9,10,11,12,13,14},{18,17, 1, 2, 3, 6, 7, 8}}; // pins of version 1.0 using DP32 board definition
#endif
#if defined(_BOARD_HELVEPIC32_)
uint8_t nP[2][8] = {{ 0, 1, 2, 3, 4, 5, 6, 7},{ 8, 9,10,11,12,13,14,15}}; // pins of version 1.0 using HelvePic32 board definition
//uint8_t nP[2][8] = {{ 8, 9,10,11,12,13,14,15},{ 0, 1, 2, 3, 4, 5, 6, 7}}; // pins of version 1.0 using HelvePic32 board definition
#endif
#if defined(_BOARD_HELVEPIC32A_)
uint8_t nP[2][8] = {{ 0, 1, 2, 3, 4, 5, 6, 7},{ 8, 9,10,11,12,13,14,15}}; // pins of version 1.0 using HelvePic32 board definition
//uint8_t nP[2][8] = {{ 8, 9,10,11,12,13,14,15},{ 0, 1, 2, 3, 4, 5, 6, 7}}; // pins of version 1.0 using HelvePic32 board definition
#endif
#if defined(_BOARD_FUBARINO_MINI_)
uint8_t nP[2][8] = {{23,17, 5, 6, 7, 8, 9,10},{18,17,24,25,26, 0, 3, 4}}; // pins of version 1.0 using Fubarino mini board definition
#endif

#if defined(__AVR__)
volatile uint8_t *pP[2][8];
uint8_t           bP[2][8];
#elif defined(__PIC32MX__)
volatile uint32_t *pP[2][8];
uint32_t           bP[2][8];
#endif 

void _HelvePic32_IO_Init() {
	for (uint8_t i=0; i<2; i++){
		for (uint8_t j=0; j<8; j++){
			pP[i][j] = portOutputRegister(digitalPinToPort(nP[i][j]));
			bP[i][j] = digitalPinToBitMask(nP[i][j]);
		}
	}
}
// *********************************************
// Library interface description
// *********************************************
class HelvePic32
{
  public:

  private:
};

#endif
